/* *******************************************************************************************
	This file contains the functions I used for my genetic algorithm. These 
	functions helped me to create my league arrays, crossover, mutate, and run my fitness 
	function (find the difference of the leagues).
   ******************************************************************************************* */

#include "Functions.h"
#include "Team.h"
#include "BaseballPlayer.h"
#include "MyForm.h"

double findDifferenceSHOW(Team t[], int num)
{
	double greatest = t[0].getTeamWAR();
	double least = t[0].getTeamWAR();
	double temp, difference;

	for (int i = 0; i < num; i++)
	{
		temp = t[i].getTeamWAR();
		if (temp > greatest)
			greatest = temp;
		if (temp < least)
			least = temp;
	}
	difference = (greatest - least);

	return difference;
}
double findDifferenceNOSHOW(Team t[], int num)
{
	double greatest = t[0].getTeamWAR();
	double least = t[0].getTeamWAR();
	double temp, difference;

	for (int i = 0; i < num; i++)
	{
		temp = t[i].getTeamWAR();
		if (temp > greatest)
			greatest = temp;
		if (temp < least)
			least = temp;
	}
	difference = (greatest - least);

	return difference;
}
void makeTeamsArray(string t[])
{
	ifstream inFile;
	inFile.open("teams.txt");  //open file for reading
	int i = 0;
	{
		for (string line; getline(inFile, line); )
		{
			t[i] = line;
			i++;
		}
	}
	inFile.close();  //close file
}
void makePlayerArray(Player p[])
{
	ifstream inFile;
	inFile.open("baseball.txt");  //open file for reading
	int i = 0;
	{
		for (string line; getline(inFile, line); )
		{
			p[i].getPlayer(line);
			i++;
		}
	}
	inFile.close();  //close file
}
void draftTeam(string tName, Player team[], double & teamWAR, Player p[], int teamSize)
{
	random_device rd; // obtain a random number from hardware
	mt19937 gen(rd()); // seed the generator
	uniform_int_distribution<> distr(0, 559); // define the range	}

	int playerCount = 0;
	int pCount = 0;
	int cCount = 0;
	int infCount = 0;
	int ofCount = 0;

	teamWAR = 0.0;

	while (playerCount < teamSize)
	{
		int random = distr(gen);
		if (p[random].isHeDrafted() == false)
		{
			if (p[random].getPosition() == "P")
			{
				if (pCount < 3)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					pCount++;
				}
			}
			else if (p[random].getPosition() == "C")
			{
				if (cCount < 2)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					cCount++;
				}
			}
			else if (p[random].getPosition() == "INF")
			{
				if (infCount < 6)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					infCount++;
				}
			}
			else if (p[random].getPosition() == "OF")
			{
				if (ofCount < 6)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					ofCount++;
				}
			}
		}
	}

	//sort here
	Player temp;
	for (int i = 0; i < TEAM_SIZE; i++)
	{
		for (int j = i + 1; j < TEAM_SIZE; j++)
		{
			if (team[i].getEnumPos() > team[j].getEnumPos())
			{
				temp = team[i];
				team[i] = team[j];
				team[j] = temp;
			}
		}
	}


	for (int i = 0; i < teamSize; i++)
	{
		teamWAR += team[i].getWAR();
	}

	return;
}
void createLeague(int numt, string teams[], Player p[], Team league[])
{
	for (int k = 0; k < numt; k++)    //place into fcn for solutions, actual teams
	{
		double teamScore;
		Player aTeam[TEAM_SIZE];
		draftTeam(teams[k], aTeam, teamScore, p, TEAM_SIZE);
		league[k].InitTheTeam(teams[k], aTeam, teamScore);
	}

	league->releaseAll(p);
	return;
}
int setupNumTeams()
{
	int numt = 0;
	while (true)
	{
		cout << "Enter desired number of teams in each league (do not go over 15 for now):   ";
		cin >> numt;
		cout << endl;
		if (numt > 15 || numt <= 0)
			cout << "Invalid number of teams... try again" << endl;
		else
			break;
	}

	return numt;
}
int setupNumLeagues()
{
	int numl = 0;
	while (true)
	{
		cout << "Enter number of leagues per Generation:   ";
		cin >> numl;
		cout << endl;
		if (numl > 20 || numl <= 0)
			cout << "Invalid number of leagues... try again" << endl;
		else
			break;
	}

	return numl;
}
void swapArrays(Team arr1[], Team arr2[], int size) {
	Team temp[NUMTEAMS];
	for (int i = 0; i < size; i++) {
		temp[i] = arr1[i];
		arr1[i] = arr2[i];
		arr2[i] = temp[i];
	}

	return;
}
void tradePlayers(Team league[], int numteams, int numleagues, int rnum)
{
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

	int randteam1, randteam2, randplayer1, randplayer2;
	Player p1, p2;
	while (true)
	{
		randteam1 = rand() % numteams + 0;
		randteam2 = rand() % numteams + 0;
		if (randteam1 != randteam2)
			break;
	}

	for (int k = 0; k < 5; k++)   //swap players k dif times
	{
		while (true)
		{
			randplayer1 = rand() % TEAM_SIZE + 0;
			randplayer2 = rand() % TEAM_SIZE + 0;
			if (randplayer1 != randplayer2 && randplayer1 < randplayer2)
				break;
		}

		for (int i = randplayer1; i <= randplayer2; i++)
		{
			p1 = league[randteam1].getPlayer(i);     //player from team 1 at index
			p2 = league[randteam2].getPlayer(i);     //player from team 2 at index
			league[randteam1].setPlayer(i, p2);      //swap
			league[randteam2].setPlayer(i, p1);      //swap
		}
	}
	return;
}
void copyArrays(Team orig[], Team newarr[], int numleag, int numt)
{
	Team temp[NUMTEAMS];
	for (int i = 0; i < numt; i++)
	{
		temp[i] = newarr[i];
		orig[i] = temp[i];
	}

	return;
}
void playerMutation(Team league[], int numteams, int numleagues, int rnum)
{
	Player temp;
	double pWAR;
	int randteam = rand() % numteams + 0;
	int randplayer = rand() % TEAM_SIZE + 0;

	double adjustment = -3 + static_cast<double>(rand()) / (RAND_MAX / (3 - (-3)));

	temp = league[randteam].getPlayer(randplayer);
	pWAR = temp.getWAR();
	pWAR = pWAR + adjustment;
	double newWar = round(pWAR * 10) / 10.0;
	temp.changeWAR(newWar);
	league[randteam].setPlayer(randplayer, temp);

	return;
}
