/* *******************************************************************************************
	This file is where most of my work is held. This is the file that contains my genetic 
	algorithm and the code for my windows form. Once the start button is clicked on the form, 
	the start button handler checks all variables to ensure that there will not be errors 
	and then calls getGeneration() which receives the variables and runs the algorithm.
   ******************************************************************************************* */

#pragma once
#include <math.h>
#include <vector>
#include <algorithm>
#include<iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <limits>
#include <array>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cmath>
#include <Windows.h>
#include "BaseballPlayer.h"
#include "Team.h"
#include "Functions.h"

namespace projectApril25 {
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Summary for MyForm
	/// </summary>
	public ref class MyForm : public System::Windows::Forms::Form
	{
	public:
		MyForm(void)
		{
			InitializeComponent();
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MyForm()
		{

		}
		
		private: System::Windows::Forms::Label^  label1;
		private: System::Windows::Forms::NumericUpDown^ numLeagues;
		private: System::Windows::Forms::Label^ label3;
		private: System::Windows::Forms::NumericUpDown^ numTopDogs;
		private: System::Windows::Forms::Label^ label4;
		private: System::Windows::Forms::Label^ label5;
		private: System::Windows::Forms::NumericUpDown^ numTrades;

		private: System::Windows::Forms::NumericUpDown^ numMutations;
		private: System::Windows::Forms::Label^ label7;
		private: System::Windows::Forms::Label^ label6;

		private: System::Windows::Forms::Label^ label9;
		private: System::Windows::Forms::NumericUpDown^ numPopulations;
		private: System::Windows::Forms::Label^ label10;
		private: System::Windows::Forms::Label^ label11;
		private: System::Windows::Forms::NumericUpDown^ numDifference;
		private: System::Windows::Forms::Label^ label12;
		private: System::Windows::Forms::NumericUpDown^ numToDisplay;
		private: System::Windows::Forms::Button^ button1;
		private: System::Windows::Forms::GroupBox^ groupBox1;
		private: System::Windows::Forms::GroupBox^ groupBox2;

		private: System::Windows::Forms::RichTextBox^  genOutput;
	
	protected:
	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->numLeagues = (gcnew System::Windows::Forms::NumericUpDown());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->numTopDogs = (gcnew System::Windows::Forms::NumericUpDown());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->numTrades = (gcnew System::Windows::Forms::NumericUpDown());
			this->numMutations = (gcnew System::Windows::Forms::NumericUpDown());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->numPopulations = (gcnew System::Windows::Forms::NumericUpDown());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->numDifference = (gcnew System::Windows::Forms::NumericUpDown());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->numToDisplay = (gcnew System::Windows::Forms::NumericUpDown());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->genOutput = (gcnew System::Windows::Forms::RichTextBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numLeagues))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numTopDogs))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numTrades))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numMutations))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numPopulations))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numDifference))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numToDisplay))->BeginInit();
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AccessibleName = L"focuslabel";
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(17, 47);
			this->label1->Margin = System::Windows::Forms::Padding(4, 0, 4, 0);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(12, 17);
			this->label1->TabIndex = 2;
			this->label1->Text = L" ";
			// 
			// numLeagues
			// 
			this->numLeagues->Location = System::Drawing::Point(20, 51);
			this->numLeagues->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 20, 0, 0, 0 });
			this->numLeagues->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->numLeagues->Name = L"numLeagues";
			this->numLeagues->Size = System::Drawing::Size(120, 22);
			this->numLeagues->TabIndex = 7;
			this->numLeagues->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 10, 0, 0, 0 });
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(17, 32);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(133, 17);
			this->label3->TabIndex = 8;
			this->label3->Text = L"Number of Leagues";
			// 
			// numTopDogs
			// 
			this->numTopDogs->Location = System::Drawing::Point(20, 111);
			this->numTopDogs->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 5, 0, 0, 0 });
			this->numTopDogs->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->numTopDogs->Name = L"numTopDogs";
			this->numTopDogs->Size = System::Drawing::Size(120, 22);
			this->numTopDogs->TabIndex = 9;
			this->numTopDogs->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2, 0, 0, 0 });
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(17, 90);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(136, 17);
			this->label4->TabIndex = 10;
			this->label4->Text = L"Number of TopDogs";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(17, 151);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(123, 17);
			this->label5->TabIndex = 11;
			this->label5->Text = L"Number of Trades";
			// 
			// numTrades
			// 
			this->numTrades->Location = System::Drawing::Point(22, 170);
			this->numTrades->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 18, 0, 0, 0 });
			this->numTrades->Name = L"numTrades";
			this->numTrades->Size = System::Drawing::Size(120, 22);
			this->numTrades->TabIndex = 12;
			this->numTrades->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 6, 0, 0, 0 });
			// 
			// numMutations
			// 
			this->numMutations->Location = System::Drawing::Point(20, 233);
			this->numMutations->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 18, 0, 0, 0 });
			this->numMutations->Name = L"numMutations";
			this->numMutations->Size = System::Drawing::Size(120, 22);
			this->numMutations->TabIndex = 13;
			this->numMutations->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2, 0, 0, 0 });
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(17, 210);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(139, 17);
			this->label7->TabIndex = 15;
			this->label7->Text = L"Number of Mutations";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(293, 321);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(307, 17);
			this->label6->TabIndex = 16;
			this->label6->Text = L"#Leagues = #TopDogs + #Trades + #Mutations";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(6, 32);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(181, 17);
			this->label9->TabIndex = 18;
			this->label9->Text = L"Max Number of Populations";
			// 
			// numPopulations
			// 
			this->numPopulations->Increment = System::Decimal(gcnew cli::array< System::Int32 >(4) { 100, 0, 0, 0 });
			this->numPopulations->Location = System::Drawing::Point(9, 51);
			this->numPopulations->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->numPopulations->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->numPopulations->Name = L"numPopulations";
			this->numPopulations->Size = System::Drawing::Size(168, 22);
			this->numPopulations->TabIndex = 19;
			this->numPopulations->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 500, 0, 0, 0 });
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(75, 80);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(21, 17);
			this->label10->TabIndex = 20;
			this->label10->Text = L"or";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(6, 105);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(125, 17);
			this->label11->TabIndex = 21;
			this->label11->Text = L"League Difference";
			// 
			// numDifference
			// 
			this->numDifference->DecimalPlaces = 1;
			this->numDifference->Increment = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 65536 });
			this->numDifference->Location = System::Drawing::Point(9, 124);
			this->numDifference->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 20, 0, 0, 0 });
			this->numDifference->Name = L"numDifference";
			this->numDifference->Size = System::Drawing::Size(168, 22);
			this->numDifference->TabIndex = 22;
			this->numDifference->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 50, 0, 0, 65536 });
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(553, 246);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(190, 17);
			this->label12->TabIndex = 23;
			this->label12->Text = L"Display Every N Generations";
			// 
			// numToDisplay
			// 
			this->numToDisplay->Increment = System::Decimal(gcnew cli::array< System::Int32 >(4) { 25, 0, 0, 0 });
			this->numToDisplay->Location = System::Drawing::Point(556, 269);
			this->numToDisplay->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000, 0, 0, 0 });
			this->numToDisplay->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->numToDisplay->Name = L"numToDisplay";
			this->numToDisplay->Size = System::Drawing::Size(165, 22);
			this->numToDisplay->TabIndex = 24;
			this->numToDisplay->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 50, 0, 0, 0 });
			this->numToDisplay->ValueChanged += gcnew System::EventHandler(this, &MyForm::numToDisplay_ValueChanged);
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(90, 473);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(75, 23);
			this->button1->TabIndex = 25;
			this->button1->Text = L"Start";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &MyForm::onStartBtnClick);
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->label9);
			this->groupBox1->Controls->Add(this->numPopulations);
			this->groupBox1->Controls->Add(this->label10);
			this->groupBox1->Controls->Add(this->label11);
			this->groupBox1->Controls->Add(this->numDifference);
			this->groupBox1->Location = System::Drawing::Point(556, 36);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(200, 170);
			this->groupBox1->TabIndex = 26;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Stopping Criteria";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->label3);
			this->groupBox2->Controls->Add(this->numLeagues);
			this->groupBox2->Controls->Add(this->label4);
			this->groupBox2->Controls->Add(this->numTopDogs);
			this->groupBox2->Controls->Add(this->label5);
			this->groupBox2->Controls->Add(this->numTrades);
			this->groupBox2->Controls->Add(this->numMutations);
			this->groupBox2->Controls->Add(this->label7);
			this->groupBox2->Location = System::Drawing::Point(276, 36);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(200, 270);
			this->groupBox2->TabIndex = 27;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Genetic Alg Parameters";
			// 
			// genOutput
			// 
			this->genOutput->Location = System::Drawing::Point(12, 12);
			this->genOutput->Name = L"genOutput";
			this->genOutput->Size = System::Drawing::Size(255, 445);
			this->genOutput->TabIndex = 28;
			this->genOutput->Text = L"";
			this->genOutput->TextChanged += gcnew System::EventHandler(this, &MyForm::genOutput_TextChanged);
			// 
			// MyForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::SystemColors::Control;
			this->ClientSize = System::Drawing::Size(1074, 517);
			this->Controls->Add(this->genOutput);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->button1);
			this->Controls->Add(this->numToDisplay);
			this->Controls->Add(this->label12);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label1);
			this->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(12)), static_cast<System::Int32>(static_cast<System::Byte>(12)),
				static_cast<System::Int32>(static_cast<System::Byte>(12)));
			this->Margin = System::Windows::Forms::Padding(4);
			this->Name = L"MyForm";
			this->Text = L"MainMenu";
			this->Load += gcnew System::EventHandler(this, &MyForm::MyForm_Load);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numLeagues))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numTopDogs))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numTrades))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numMutations))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numPopulations))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numDifference))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numToDisplay))->EndInit();
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: System::Void MyForm_Load(System::Object^  sender, System::EventArgs^  e) {
	}

	private: System::Void getGenerations(int ACTUALLEAGUES, int numTopDogs, int numTrades, int numMutations, 
											int maxGens, double leagueDiff, int numGenDisplay)
	{
		int genTotalCnt = 0;
		genOutput->SelectionColor = Color::Green;
		genOutput->Text += "IN PROGRESS.....\n";
		genOutput->SelectionColor = Color::Black;

		ostringstream t;
		Player playerArray[playerSize];
		makePlayerArray(playerArray);     //call a function to create array of Player

		string allTeams[NUMTEAMS];
		makeTeamsArray(allTeams);

		const int ACTUALTEAMS = 16;    //KEEP AT 16

		Team** multiLeagues;
		multiLeagues = new Team *[NUMLEAGUES];  // CAN BE A VARIABLE with number of Leagues from the user
		for (int m = 0; m < ACTUALLEAGUES; m++)
			multiLeagues[m] = new Team[NUMTEAMS];  // CAN BE A VARIABLE with number of teams in league from user


		for (int i = 0; i < ACTUALLEAGUES; i++)  //PUSHBACK LEAGUES
		{
			createLeague(ACTUALTEAMS, allTeams, playerArray, multiLeagues[i]);
			findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
			multiLeagues[i]->releaseAll(playerArray);
		}

		//display
		System::String^ genZero = "GENERATION  0!\n";
		genOutput->Text += genZero;
		for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
		{
			double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
			System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
			genOutput->Text += temp;
		}
		genOutput->Text += "\n\n";


		cout << "========================================================================" << endl << endl;

		int gencount = 1;
		if (numTopDogs > ACTUALLEAGUES)
		{
			cout << "ERROR ERROR ERROR... numTopDogs exceeds num ACTUALLEAGUES" << endl;
			exit(EXIT_FAILURE);
		}

		int random_league;
		int random_league_mut;

		double maxDifference[NUMLEAGUES];
		int numloops = 0;
		srand(333);

		bool loopStop = false;

		//GENERATION LOOP
		while (loopStop == false)
		{
			for (int i = 0; i < ACTUALLEAGUES; i++)
				maxDifference[i] = findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);

			//SORTS LEAGUES IN SOLUTION BY WAR
			Team temp[NUMTEAMS];
			for (int i = 0; i < ACTUALLEAGUES; i++)
			{
				for (int j = i + 1; j < ACTUALLEAGUES; j++)
				{
					if (maxDifference[i] > maxDifference[j])
					{
						swapArrays(temp, multiLeagues[i], ACTUALTEAMS);
						swapArrays(multiLeagues[i], multiLeagues[j], ACTUALTEAMS);
						swapArrays(multiLeagues[j], temp, ACTUALTEAMS);
						swap(maxDifference[i], maxDifference[j]);
					}

					for (int i = 0; i < ACTUALLEAGUES; i++)
					{
						findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);
					}
				}
			}


			//Create array for NEXT GEN
			Team** nextGen;
			nextGen = new Team *[NUMLEAGUES];
			for (int m = 0; m < ACTUALLEAGUES; m++)
				nextGen[m] = new Team[NUMTEAMS];
			for (int i = 0; i < numTopDogs; i++)     //place top num of leagues (numTopDog) into next gen automatically
			{
				copyArrays(nextGen[i], multiLeagues[i], ACTUALLEAGUES, ACTUALTEAMS);
			}


			//Crossover 
			int nextGenCtr = numTopDogs;
			for (int i = 0; i < numTrades; i++)
			{
				random_league = rand() % ACTUALLEAGUES + 0;
				copyArrays(nextGen[nextGenCtr], multiLeagues[random_league], ACTUALLEAGUES, ACTUALTEAMS);
				tradePlayers(nextGen[nextGenCtr], ACTUALTEAMS, ACTUALLEAGUES, random_league);
				nextGenCtr++;
			}


			//Mutate 
			for (int i = 0; i < numMutations; i++)
			{
				random_league_mut = rand() % ACTUALLEAGUES;
				copyArrays(nextGen[nextGenCtr], multiLeagues[random_league_mut], ACTUALLEAGUES, ACTUALTEAMS);
				playerMutation(nextGen[nextGenCtr], ACTUALTEAMS, ACTUALLEAGUES, random_league_mut);
				nextGenCtr++;
			}


			//copy next gen into multiLeague
			for (int i = 0; i < ACTUALLEAGUES; i++)
			{
				copyArrays(multiLeagues[i], nextGen[i], ACTUALLEAGUES, ACTUALTEAMS);
			}


			numloops++;

			//SORT ARRAY
			for (int i = 0; i < ACTUALLEAGUES; i++)
				maxDifference[i] = findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);

			//SORTS LEAGUES IN SOLUTION BY WAR
			Team temp2[NUMTEAMS];
			for (int i = 0; i < ACTUALLEAGUES; i++)
			{
				for (int j = i + 1; j < ACTUALLEAGUES; j++)
				{
					if (maxDifference[i] > maxDifference[j])
					{
						swapArrays(temp2, multiLeagues[i], ACTUALTEAMS);
						swapArrays(multiLeagues[i], multiLeagues[j], ACTUALTEAMS);
						swapArrays(multiLeagues[j], temp2, ACTUALTEAMS);
						swap(maxDifference[i], maxDifference[j]);
					}

					for (int i = 0; i < ACTUALLEAGUES; i++)
					{
						findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);
					}
				}
			}

			genTotalCnt++;
			double triggerWAR;

			//Print every nth generation
			if (gencount == numGenDisplay)
			{
				System::String^ genText = "GENERATION  " + numloops.ToString() + "!\n";
				genOutput->Text += genText;
				for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
				{
					double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
					if (i == 0)
					{
						triggerWAR = tempDifference;
					}
					System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
					genOutput->Text += temp;
				}

				System::String^ newLine = "\n";
				genOutput->Text += newLine;
				genOutput->Text += newLine;
				gencount = 1;
				genOutput->SelectionStart = genOutput->Text->Length;
				genOutput->ScrollToCaret();
				Sleep(750);

				if (genTotalCnt == maxGens)
				{
					loopStop = true;
					genOutput->SelectionColor = Color::Green;
					genOutput->Text += "Simulation Stopped Due To:\nMax Gens Reached 1.\nFinal Generation:\n\n\n";
					genOutput->SelectionColor = Color::Black;

					System::String^ genText = "GENERATION  " + numloops.ToString() + "!\n";
					genOutput->Text += genText;
					for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
					{
						double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
						System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
						genOutput->Text += temp;
					}
				}

				if (triggerWAR <= leagueDiff)
				{
					loopStop = true;
					genOutput->SelectionColor = Color::Green;
					genOutput->Text += "Simulation Stopped Due To:\nMin Difference Reached 1.\nFinal Generation:\n\n\n";
					genOutput->SelectionColor = Color::Black;

					System::String^ genText = "GENERATION  " + numloops.ToString() + "!\n";
					genOutput->Text += genText;
					for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
					{
						double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
						System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
						genOutput->Text += temp;
					}
				}
			} 
			else
			{
				for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
				{
					double tempDifference2 = findDifferenceNOSHOW(multiLeagues[i], ACTUALLEAGUES);
					if (i == 0)
					{
						triggerWAR = tempDifference2;
					}
				}
				gencount++;
				if (genTotalCnt == maxGens)
				{
					loopStop = true;
					genOutput->SelectionColor = Color::Green;
					genOutput->Text += "Simulation Stopped Due To:\nMax Gens Reached 2.\nFinal Generation:\n\n\n";
					genOutput->SelectionColor = Color::Black;

					System::String^ genText = "GENERATION  " + numloops.ToString() + "!\n";
					genOutput->Text += genText;
					for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
					{
						double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
						System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
						genOutput->Text += temp;
					}
				}

				if (triggerWAR <= leagueDiff)
				{
					loopStop = true;
					genOutput->SelectionColor = Color::Green;
					genOutput->Text += "Simulation Stopped Due To:\nMin Difference Reached 2.\nFinal Generation:\n\n\n";
					genOutput->SelectionColor = Color::Black;

					System::String^ genText = "GENERATION  " + numloops.ToString() + "!\n";
					genOutput->Text += genText;
					for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
					{
						double tempDifference = findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
						System::String^ temp = "Difference of League " + tempDifference.ToString() + "\n";
						genOutput->Text += temp;
					}
				}
			}
		}
	}


	//OnCLick Start Btn
	private: System::Void onStartBtnClick(System::Object^ sender, System::EventArgs^ e) 
	{
		int leagues = (int)numLeagues->Value;
		int topdogs = (int)(numTopDogs->Value);
		int trades = (int)numTrades->Value;
		int mutations = (int)numMutations->Value;
		int maxGens = (int)numPopulations->Value;
		double leagueDiff = (double)numDifference->Value;
		int numGenDisplay = (int)numToDisplay->Value;

		if ((leagues != topdogs + trades + mutations) || (numGenDisplay > maxGens))
			System::Windows::Forms::MessageBox::Show("Parameters Not OK!...try again", "Message Box Title", 
															MessageBoxButtons::OK, MessageBoxIcon::Information);
		else
		{
			getGenerations(leagues, topdogs, trades, mutations, maxGens, leagueDiff, numGenDisplay);
		}

	}

private: System::Void genOutput_TextChanged(System::Object^  sender, System::EventArgs^  e) 
{
	genOutput->SelectionStart = genOutput->Text->Length;
	genOutput->ScrollToCaret();
}
private: System::Void numToDisplay_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
}
};
}