/* *******************************************************************************************
	This file contains my Team object private variables and functions. Having a team object
	helped me create leagues much easier and enabled me to access different information
	about a team and to retrieve players.
   ******************************************************************************************* */

#ifndef TEAM_h
#define TEAM_h
#include <string>
#include "BaseballPlayer.h"

using namespace std;

const int TEAM_SIZE = 17;
class Team
{
private:
	string teamName;
	double teamWAR;
	Player theTeam[TEAM_SIZE];

public:
	Team(int n) 
	{
		// Constructor code here
	}
	Team(string n = "mlb")
	{
		teamName = n;
		teamWAR = 0;
	}
	void InitTheTeam(string n, Player p[], double score) {
		teamName = n;
		teamWAR = score;
		for (int i = 0; i < TEAM_SIZE; i++)
		{
			theTeam[i] = p[i];
		}
	}
	double getTeamWAR()
	{
		double sum = 0;
		for (int i = 0; i < TEAM_SIZE; i++)
			sum += theTeam[i].getWAR();
		teamWAR = sum;
		return teamWAR;
	}
	Player getPlayer(unsigned int i) const
	{
		if (i >= TEAM_SIZE)
			cout << "Player index invalid" << endl;
		else
			return theTeam[i];  // check for valid i
	}
	void setPlayer(unsigned int i, const Player & bbp)
	{
		if (i >= TEAM_SIZE)
			cout << "Player index invalid" << endl;
		else
			theTeam[i] = bbp;  // check for valid i ... probably same position	
	}
	void releaseAll(Player arr[])
	{
		for (int i = 0; i < playerSize; i++)
		{
			arr[i].releasePlayer();
		}
	}
};
#endif 
